/*-----------------------------------*/
/*           >>>Conduits<<<          */
/*            Theo D'Hondt           */
/*   VUB Programming Technology Lab  */
/*             (c) 1997              */
/*-----------------------------------*/

package Conduits;

abstract class Conduit extends Thread
  { private String name;
    protected  int capacity;
    protected  int time = 0;
    protected  int content = 0;
    
    protected Conduit(String nam, int cap)
      { name = nam;
        capacity = cap; }

    final protected void report(String msg, int vol)
      { System.out.println("t=\t" + time + '\t' + name + '\t' + msg + '\t' + vol); }

    final protected void error(String msg)
      { System.out.println(name + "\t=>\t" + msg); 
        stop(); }
        
    abstract protected int fill();
                        
    protected void tick()
      { int flow = fill();
        content += flow;
        time++;
        report("filled    ", flow);
        report("contains  ", content);  }
    
    final public void run()
      { while (time < 50)
          { tick(); 
            yield(); }}}
