/*-----------------------------------*/
/*           >>>Conduits<<<          */
/*            Theo D'Hondt           */
/*   VUB Programming Technology Lab  */
/*             (c) 1997              */
/*-----------------------------------*/

package Conduits;

abstract class DrainableConduit extends Conduit
  { private boolean isFilled = false;
    
    protected DrainableConduit(String nam, int cap)
      { super(nam, cap); }
      
    synchronized protected void tick()
      { if (isFilled)
          try
            { wait(); }
          catch (InterruptedException e)
            { error(e.toString()); }
        isFilled = true; 
        super.tick(); 
        notify(); }
    
    protected int available(int max)
      { if (content > max)
          return max;
        else
          return content; }

    synchronized final public int drain(int max)
      { int flow;
        if (!isFilled)
          try
            { wait(); }
          catch (InterruptedException e)
            { error(e.toString()); }      
        flow = available(max);
		    isFilled = false; 
		    report("drained   ", flow);
		    content -= flow;
		    notify();
        return flow; }}
