/*-----------------------------------*/
/*           >>>Conduits<<<          */
/*            Theo D'Hondt           */
/*   VUB Programming Technology Lab  */
/*             (c) 1997              */
/*-----------------------------------*/

package Conduits;

import Conduits.*;

final public class Pipe extends DrainableConduit
  { final static int pipeLength = 10;
  
    private DrainableConduit inConduit;
    private int cell[] = new int[pipeLength];
    
    public Pipe(String nam, int cap, DrainableConduit inc)
      { super(nam, cap);
        inConduit = inc; 
        for(int index = 0; index < pipeLength; index++)
          cell[index] = 0; }

    protected int fill()
      { int flow = inConduit.drain(capacity - cell[0]);
        int free;
        int available;
        cell[0] += flow;
        for(int index = pipeLength - 1; index > 0; index--)
          { free = capacity - cell[index];
            available = cell[index - 1];
            if (available > free)
              available = free;
            cell[index] += available;
            cell[index - 1] -= available; }
        return flow; }
                
    protected int available(int max)
      { int flow;
        if (cell[pipeLength - 1] > max)
          flow = max;
        else
          flow = cell[pipeLength - 1];
        cell[pipeLength - 1] -= flow; 
        return flow; }}
